
import numpy
from harkpython import harktype
from harkpython import harkbasenode

class HarkNode(harkbasenode.HarkBaseNode):
    def __init__(self):
        self.outputNames=("OUT_OBJECT_BOOL", "OUT_OBJECT_INT", "OUT_OBJECT_FLOAT", "OUT_OBJECT_COMPLEX_FLOAT",
                          "OUT_OBJECT_STRING", "OUT_OBJECT_NULL",
                          "OUT_VECTOR_BOOL", "OUT_VECTOR_INT", "OUT_VECTOR_FLOAT", "OUT_VECTOR_COMPLEX_FLOAT",
                          "OUT_NUMPY_VECTOR_INT", "OUT_NUMPY_VECTOR_FLOAT", "OUT_NUMPY_VECTOR_COMPLEX_FLOAT",
                          "OUT_MATRIX_BOOL", "OUT_MATRIX_INT", "OUT_MATRIX_FLOAT", "OUT_MATRIX_COMPLEX_FLOAT",
                          "OUT_NUMPY_MATRIX_INT", "OUT_NUMPY_MATRIX_FLOAT", "OUT_NUMPY_MATRIX_COMPLEX_FLOAT",
                          "OUT_MAP_OBJECT_BOOL", "OUT_MAP_OBJECT_INT", "OUT_MAP_OBJECT_FLOAT", "OUT_MAP_OBJECT_COMPLEX_FLOAT",
                          "OUT_MAP_VECTOR_INT", "OUT_MAP_VECTOR_FLOAT", "OUT_MAP_VECTOR_COMPLEX_FLOAT",
                          "OUT_MAP_NUMPY_VECTOR_INT", "OUT_MAP_NUMPY_VECTOR_FLOAT", "OUT_MAP_NUMPY_VECTOR_COMPLEX_FLOAT",
                          "OUT_MAP_MATRIX_INT", "OUT_MAP_MATRIX_FLOAT", "OUT_MAP_MATRIX_COMPLEX_FLOAT",
                          "OUT_MAP_NUMPY_MATRIX_INT", "OUT_MAP_NUMPY_MATRIX_FLOAT", "OUT_MAP_NUMPY_MATRIX_COMPLEX_FLOAT",
                          "OUT_VECTOR_SOURCE",
                          "OUT_CM",
                          "OUT_DUMMY",)
        self.outputTypes=("prim_bool", "prim_int", "prim_float", "prim_complex", "prim_string", "prim_null",
                          "vector_bool", "vector_int", "vector_float", "vector_complex",
                          "vector_int", "vector_float", "vector_complex",
                          "matrix_bool", "matrix_int", "matrix_float", "matrix_complex",
                          "matrix_int", "matrix_float", "matrix_complex",
                          "map_prim_bool", "map_prim_int", "map_prim_float", "map_prim_complex",
                          "map_vector_int", "map_vector_float", "map_vector_complex",
                          "map_vector_int", "map_vector_float", "map_vector_complex",
                          "map_matrix_int", "map_matrix_float", "map_matrix_complex",
                          "map_matrix_int", "map_matrix_float", "map_matrix_complex",
                          "vector_source",
                          "matrix_complex",
                          "prim_int",)

    def calculate(self):
        print("bool => {}:\n  {}\n".format(type(self.IN_BOOL), self.IN_BOOL))
        print("int => {}:\n  {}\n".format(type(self.IN_INT), self.IN_INT))
        print("float => {}:\n  {}\n".format(type(self.IN_FLOAT), self.IN_FLOAT))
        print("std::string => {}:\n  {}\n".format(type(self.IN_STRING), self.IN_STRING))
        print("Bool => {}:\n  {}\n".format(type(self.IN_OBJECT_BOOL), self.IN_OBJECT_BOOL))
        print("Int => {}:\n  {}\n".format(type(self.IN_OBJECT_INT), self.IN_OBJECT_INT))
        print("Float => {}:\n  {}\n".format(type(self.IN_OBJECT_FLOAT), self.IN_OBJECT_FLOAT))
        print("Double => {}:\n  {}\n".format(type(self.IN_OBJECT_DOUBLE), self.IN_OBJECT_DOUBLE))
        print("Complex<float> => {}:\n  {}\n".format(type(self.IN_OBJECT_COMPLEX_FLOAT), self.IN_OBJECT_COMPLEX_FLOAT))
        print("Complex<double> => {}:\n  {}\n".format(type(self.IN_OBJECT_COMPLEX_DOUBLE), self.IN_OBJECT_COMPLEX_DOUBLE))
        print("Char => {}:\n  {}\n".format(type(self.IN_OBJECT_CHAR), self.IN_OBJECT_CHAR))
        print("String => {}:\n  {}\n".format(type(self.IN_OBJECT_STRING), self.IN_OBJECT_STRING))
        print("NilObject => {}:\n  {}\n".format(type(self.IN_OBJECT_NULL), self.IN_OBJECT_NULL))
        print("Vector<int> => {}:\n  {}\n".format(type(self.IN_VECTOR_INT), self.IN_VECTOR_INT))
        print("Vector<float> => {}:\n  {}\n".format(type(self.IN_VECTOR_FLOAT), self.IN_VECTOR_FLOAT))
        print("Vector<std::complex<float> > => {}:\n  {}\n".format(type(self.IN_VECTOR_COMPLEX_FLOAT), self.IN_VECTOR_COMPLEX_FLOAT))
        print("Vector<Bool> => {}:\n  {}\n".format(type(self.IN_VECTOR_OBJECT_BOOL), self.IN_VECTOR_OBJECT_BOOL))
        print("Vector<Int> => {}:\n  {}\n".format(type(self.IN_VECTOR_OBJECT_INT), self.IN_VECTOR_OBJECT_INT))
        print("Vector<Float> => {}:\n  {}\n".format(type(self.IN_VECTOR_OBJECT_FLOAT), self.IN_VECTOR_OBJECT_FLOAT))
        print("Vector<Double> => {}:\n  {}\n".format(type(self.IN_VECTOR_OBJECT_DOUBLE), self.IN_VECTOR_OBJECT_DOUBLE))
        print("Vector<Complex<float> => {}:\n  {}\n".format(type(self.IN_VECTOR_OBJECT_COMPLEX_FLOAT), self.IN_VECTOR_OBJECT_COMPLEX_FLOAT))
        print("Vector<Char> => {}:\n  {}\n".format(type(self.IN_VECTOR_OBJECT_CHAR), self.IN_VECTOR_OBJECT_CHAR))
        print("Matrix<int> => {}:\n  {}\n".format(type(self.IN_MATRIX_INT), self.IN_MATRIX_INT))
        print("Matrix<float> => {}:\n  {}\n".format(type(self.IN_MATRIX_FLOAT), self.IN_MATRIX_FLOAT))
        print("Matrix<std::complex<float> > => {}:\n  {}\n".format(type(self.IN_MATRIX_COMPLEX_FLOAT), self.IN_MATRIX_COMPLEX_FLOAT))
        print("Matrix<Bool> => {}:\n  {}\n".format(type(self.IN_MATRIX_OBJECT_BOOL), self.IN_MATRIX_OBJECT_BOOL))
        print("Matrix<Int> => {}:\n  {}\n".format(type(self.IN_MATRIX_OBJECT_INT), self.IN_MATRIX_OBJECT_INT))
        print("Matrix<Float> => {}:\n  {}\n".format(type(self.IN_MATRIX_OBJECT_FLOAT), self.IN_MATRIX_OBJECT_FLOAT))
        print("Matrix<Double> => {}:\n  {}\n".format(type(self.IN_MATRIX_OBJECT_DOUBLE), self.IN_MATRIX_OBJECT_DOUBLE))
        print("Matrix<Complex<float> => {}:\n  {}\n".format(type(self.IN_MATRIX_OBJECT_COMPLEX_FLOAT), self.IN_MATRIX_OBJECT_COMPLEX_FLOAT))
        print("Matrix<Char> => {}:\n  {}".format(type(self.IN_MATRIX_OBJECT_CHAR), self.IN_MATRIX_OBJECT_CHAR))
        print("Map<int, Vector<float> > => {}:\n  {}\n".format(type(self.IN_MAP_VECTOR_FLOAT), self.IN_MAP_VECTOR_FLOAT))
        print("Map<int, Vector<std::complex<float> > > => {}:\n  {}\n".format(type(self.IN_MAP_VECTOR_COMPLEX_FLOAT), self.IN_MAP_VECTOR_COMPLEX_FLOAT))
        print("Map<int, Matrix<float> > => {}:\n  {}\n".format(type(self.IN_MAP_MATRIX_FLOAT), self.IN_MAP_MATRIX_FLOAT))
        print("Map<int, Matrix<std::complex<float> > => {}:\n  {}\n".format(type(self.IN_MAP_MATRIX_COMPLEX_FLOAT), self.IN_MAP_MATRIX_COMPLEX_FLOAT))
        print("Vector<Source> => {}:\n  {}\n".format(type(self.IN_VECTOR_SOURCE), self.IN_VECTOR_SOURCE))
        print("CM type (Matrix<std::complex<float> >) => {}:\n  {}\n".format(type(self.IN_CM), self.IN_CM))
        self.outputValues["OUT_OBJECT_BOOL"] = True
        self.outputValues["OUT_OBJECT_INT"] = 1
        self.outputValues["OUT_OBJECT_FLOAT"] = 1.1
        self.outputValues["OUT_OBJECT_COMPLEX_FLOAT"] = 1.1+2.2j
        self.outputValues["OUT_OBJECT_STRING"] = "Hi!"
        self.outputValues["OUT_OBJECT_NULL"] = None
        self.outputValues["OUT_VECTOR_BOOL"] = [True, True, False, True]
        self.outputValues["OUT_VECTOR_INT"] = [9, 8, 7, 6, 5, 4, 3, 2, 1]
        self.outputValues["OUT_VECTOR_FLOAT"] = [9.9, 8.8, 7.7, 6.6, 5.5, 4.4, 3.3, 2.2, 1.1]
        self.outputValues["OUT_VECTOR_COMPLEX_FLOAT"] = [9.9+1.1j, 8.8-2.2j, 7.7+3.3j, 6.6-5.5j]
        self.outputValues["OUT_NUMPY_VECTOR_INT"] = numpy.array([9, 8, 7, 6, 5, 4, 3, 2, 1])
        self.outputValues["OUT_NUMPY_VECTOR_FLOAT"] = numpy.array([9.9, 8.8, 7.7, 6.6, 5.5, 4.4, 3.3, 2.2, 1.1])
        self.outputValues["OUT_NUMPY_VECTOR_COMPLEX_FLOAT"] = numpy.array([9.9+1.1j, 8.8-2.2j, 7.7+3.3j, 6.6-5.5j])
        self.outputValues["OUT_MATRIX_BOOL"] = [[True, False],
                                                [False, True]]
        self.outputValues["OUT_MATRIX_INT"] = [[9, 8, 7],
                                               [6, 5, 4],
                                               [3, 2, 1]]
        self.outputValues["OUT_MATRIX_FLOAT"] = [[9.9, 8.8, 7.7],
                                                 [6.6, 5.5, 4.4],
                                                 [3.3, 2.2, 1.1]]
        self.outputValues["OUT_MATRIX_COMPLEX_FLOAT"] = [[9.9+1.1j, 8.8-2.2j],
                                                         [7.7+3.3j, 6.6-5.5j]]
        self.outputValues["OUT_NUMPY_MATRIX_INT"] = numpy.array([[9, 8, 7],
                                                                 [6, 5, 4],
                                                                 [3, 2, 1]])
        self.outputValues["OUT_NUMPY_MATRIX_FLOAT"] = numpy.array([[9.9, 8.8, 7.7],
                                                                   [6.6, 5.5, 4.4],
                                                                   [3.3, 2.2, 1.1]])
        self.outputValues["OUT_NUMPY_MATRIX_COMPLEX_FLOAT"] = numpy.array([[9.9+1.1j, 8.8-2.2j],
                                                                           [7.7+3.3j, 6.6-5.5j]])
        self.outputValues["OUT_MAP_OBJECT_BOOL"] = {1: True, 2: False, 3: True, 4: True}
        self.outputValues["OUT_MAP_OBJECT_INT"] = {1: 9, 2: 8, 3: 7, 4: 6}
        self.outputValues["OUT_MAP_OBJECT_FLOAT"] = {1: 9.9, 2: 8.8, 3: 7.7, 4: 6.6}
        self.outputValues["OUT_MAP_OBJECT_COMPLEX_FLOAT"] = {1: 1.1+9.9j, 2: 2.2-8.8j, 3: 3.3+7.7j, 4: 4.4-6.6j}
        self.outputValues["OUT_MAP_VECTOR_INT"] = {1: [9, 8, 7, 6, 5, 4, 3, 2, 1],
                                                   2: [1, 2, 3, 4, 5, 6, 7, 8, 9]}
        self.outputValues["OUT_MAP_VECTOR_FLOAT"] = {1: [9.9, 8.8, 7.7, 6.6, 5.5, 4.4, 3.3, 2.2, 1.1],
                                                     2: [1.1, 2.2, 3.3, 4.4, 5.5, 6.6, 7.7, 8.8, 9.9]}
        self.outputValues["OUT_MAP_VECTOR_COMPLEX_FLOAT"] = {1: [9.9+1.1j, 8.8-2.2j, 7.7+3.3j, 6.6-5.5j],
                                                             2: [1.1-9.9j, 2.2+8.8j, 3.3-7.7j, 5.5+6.6j]}
        self.outputValues["OUT_MAP_NUMPY_VECTOR_INT"] = {1: numpy.array([9, 8, 7, 6, 5, 4, 3, 2, 1]),
                                                         2: numpy.array([1, 2, 3, 4, 5, 6, 7, 8, 9])}
        self.outputValues["OUT_MAP_NUMPY_VECTOR_FLOAT"] = {1: numpy.array([9.9, 8.8, 7.7, 6.6, 5.5, 4.4, 3.3, 2.2, 1.1]),
                                                           2: numpy.array([1.1, 2.2, 3.3, 4.4, 5.5, 6.6, 7.7, 8.8, 9.9])}
        self.outputValues["OUT_MAP_NUMPY_VECTOR_COMPLEX_FLOAT"] = {1: numpy.array([9.9+1.1j, 8.8-2.2j, 7.7+3.3j, 6.6-5.5j]),
                                                                   2: numpy.array([1.1-9.9j, 2.2+8.8j, 3.3-7.7j, 5.5+6.6j])}
        self.outputValues["OUT_MAP_MATRIX_INT"] = {1: [[9, 8, 7],
                                                       [6, 5, 4],
                                                       [3, 2, 1]],
                                                   2: [[1, 2, 3],
                                                       [4, 5, 6],
                                                       [7, 8, 9]]}
        self.outputValues["OUT_MAP_MATRIX_FLOAT"] = {1: [[9.9, 8.8, 7.7],
                                                         [6.6, 5.5, 4.4],
                                                         [3.3, 2.2, 1.1]],
                                                     2: [[1.1, 2.2, 3.3],
                                                         [4.4, 5.5, 6.6],
                                                         [7.7, 8.8, 9.9]]}
        self.outputValues["OUT_MAP_MATRIX_COMPLEX_FLOAT"] = {1: [[9.9+1.1j, 8.8-2.2j],
                                                                 [7.7+3.3j, 6.6-5.5j]],
                                                             2: [[1.1-9.9j, 2.2+8.8j],
                                                                 [3.3-7.7j, 5.5+6.6j]]}
        self.outputValues["OUT_MAP_NUMPY_MATRIX_INT"] = {1: numpy.array([[9, 8, 7],
                                                                         [6, 5, 4],
                                                                         [3, 2, 1]]),
                                                         2: numpy.array([[1, 2, 3],
                                                                         [4, 5, 6],
                                                                         [7, 8, 9]])}
        self.outputValues["OUT_MAP_NUMPY_MATRIX_FLOAT"] = {1: numpy.array([[9.9, 8.8, 7.7],
                                                                           [6.6, 5.5, 4.4],
                                                                           [3.3, 2.2, 1.1]]),
                                                           2: numpy.array([[1.1, 2.2, 3.3],
                                                                           [4.4, 5.5, 6.6],
                                                                           [7.7, 8.8, 9.9]])}
        self.outputValues["OUT_MAP_NUMPY_MATRIX_COMPLEX_FLOAT"] = {1: numpy.array([[9.9+1.1j, 8.8-2.2j],
                                                                                   [7.7+3.3j, 6.6-5.5j]]),
                                                                   2: numpy.array([[1.1-9.9j, 2.2+8.8j],
                                                                                   [3.3-7.7j, 5.5+6.6j]])}
        self.outputValues["OUT_VECTOR_SOURCE"] = [{"id": 1, "x": [1.0, 0.0, 0.0], "power": 37.2},
                                                  {"id": 2, "x": [0.0, 1.0, 0.0], "power": 35.8}]
        # Although the 3-dim array of "cm" variable is "[FREQ_BINS][MICS][MICS]",
        # but HARK requires a 2-dim array of "[FREQ_BINS][MICS * MICS]".
        cm = numpy.array([[[0.9+0.0j, 0.1+0.0j, 0.0+0.0j],
                           [0.1+0.0j, 0.9+0.0j, 0.1+0.0j],
                           [0.0+0.0j, 0.1+0.0j, 0.9+0.0j]],
                          [[0.7+0.0j, 0.3+0.0j, 0.1+0.0j],
                           [0.3+0.0j, 0.7+0.0j, 0.3+0.0j],
                           [0.1+0.0j, 0.3+0.0j, 0.7+0.0j]],
                          [[0.5+0.0j, 0.2+0.0j, 0.2+0.0j],
                           [0.2+0.0j, 0.5+0.0j, 0.2+0.0j],
                           [0.2+0.0j, 0.2+0.0j, 0.5+0.0j]],
                          [[0.3+0.0j, 0.3+0.0j, 0.3+0.0j],
                           [0.3+0.0j, 0.3+0.0j, 0.3+0.0j],
                           [0.3+0.0j, 0.3+0.0j, 0.3+0.0j]]])
        self.outputValues["OUT_CM"] = cm.reshape((cm.shape[0], cm.shape[1]*cm.shape[2]))
        self.outputValues["OUT_DUMMY"] = 1

